%% Supplementary Material 1
% This script is used to generate figure 2a-2f
clear

rho=1;
T=72;
mu = 0.01;% sqrt(2)/20; %sqrt(0.2);
R0=1;
m=3;

La = T*R0*rho/mu^2;


% syms R0hat

dkmm1 = @(R0hat) -0.5*(besselk(m-2,R0hat)+besselk(m,R0hat));

G = @(R0hat) R0hat^2 /2/m *besselk(m+1,R0hat) - (m-1)*besselk(m-1,R0hat);

dispersion = @(R0hat) R0hat^4 + 2*m*(m+1)*(1.0-G(R0hat)/(R0hat*dkmm1(R0hat)))*R0hat^2 + La*m*(m^2-1)*(1-(m+1)/R0hat * besselk(m-1,R0hat)/dkmm1(R0hat));

% dkmmx = @(x) -0.5*(besselk(m-2,x)+besselk(m,x));
% Gx = @(x) x^2 /2/m *besselk(m+1,x) - (m-1)*besselk(m-1,x);
% 
% fun = @(x) x^4 + 2*m*(m+1)*(1.0-Gx(x)/(x*dkmmx(x)))*x^2 + La*m*(m^2-1)*(1-(m+1)/x * besselk(m-1,x)/dkmmx(x));

options = optimset('Display','off'); 
ig =0;
count=1; rcount=1;

for jk=1:200
    if (jk<51)
        ig = ig +1+1i; % search in first quadrant
    
    elseif (jk<101)
        if(jk==51)
            ig=0;
        end
        ig = ig -1+1i; % search in second quadrant
     elseif (jk<151)
        if(jk==101)
            ig=0;
        end
        ig = ig -1-1i; % search in third quadrant
     elseif (jk<201)
        if(jk==151)
            ig=0;
        end
        ig = ig +1-1i; % search in fourth quadrant
    end

    root(jk) = fsolve(dispersion,ig,options);

   res_r(jk,1) = abs(dispersion(root(jk))); % collect residue to verify the solution
    res_i(jk,1) = abs(dispersion(root(jk))); % collect residue to verify the solution
    
    if (res_r(jk)<1e-6 && res_i(jk)<1e-6 && double(real(root(jk)))>0) %% accepted roots
        acc_roots(count)=root(jk);
        count=count+1;
    elseif (res_r(jk)<1e-6 && res_i(jk)<1e-6 && double(real(root(jk)))<0) %% rejected roots
        rej_roots(rcount)=root(jk);
        rcount=rcount+1;
    end
 
   
jk
end

clf
plot(real(acc_roots),imag(acc_roots),'kd','MarkerFaceColor',[0.2 0.8 0],'MarkerSize',20); hold on
plot(real(rej_roots),imag(rej_roots),'ro','MarkerSize',15,'MarkerFaceColor','r'); %'MarkerFaceColor','r'
xfn = 50;%50;
yfn =50; %50;
axis([-xfn xfn -yfn yfn]);
set(gca,'XTick',-xfn:xfn:xfn);
set(gca,'YTick',-yfn:yfn:yfn);

xlabel('$\Re(\hat{R}_0)$','Interpreter','latex');
 ylabel('$\Im(\hat{R}_0)\qquad$','Interpreter','latex','rot',0);

%  ylabel('$\Im(\hat{R_0})\;\;\;$','Interpreter','latex','rot',0,'Position',[-5.8 0.2 0]);

xL = xlim;
yL = ylim;
line(xL, [0 0],'color','k','linewidth',1) %x-axis
line([0 0], yL,'color','k','linewidth',1) %y-axis
set(gca,'FontSize',35)
axis square

axes('Position',[0.4 0.6 .1 .1])
box on
plot(real(rej_roots),imag(rej_roots),'ro','MarkerSize',5,'MarkerFaceColor','r'); %'MarkerFaceColor','r'

axis([-5 0 -2 2]);
set(gca,'XTick',-5:5:0);
set(gca,'YTick',-2:2:2);
xL = xlim;
yL = ylim;
line(xL, [0 0],'color','k','linewidth',1) %x-axis
% line([0 0], yL,'color','k','linewidth',1) %y-axis
set(gca,'FontSize',27)


set(gcf,'units','inch','position',[10,80,10,10]);
set(gcf,'color','w')
%    export_fig(gcf,'R0hat_La72e4m3.eps');

