clear

%% for m=2; Fig3a
%dimension values are needed to evaluate $\hat{\sigma}$
rho=1;
T=0.5;

R0=1;
m=2;

La(1)=0.001;
omegasq = (T*m*(m^2-1) )/(rho)/R0^3;

for jk=1:139
    
  mu = sqrt(T*R0*rho/La(jk));

  temp =disp_r0hat(rho,La(jk),m,T,R0); % disp_r0hat definition is at the end of the file
    if (real(temp)<0)
      disp('R0hat not accpeted real part negative, change initial guess in fsolve');
      break;
  end
  roots(jk) = (temp/R0)^2*mu/rho/sqrt(omegasq); % $\hat{\sigma}$

  La(jk+1) = exp(0.1*jk)-1;
end

reroot = double(real(roots))';
imroot = double(imag(roots))';

 mu = sqrt(T*R0*rho/0.25);
 temp = disp_r0hat(rho,0.25,m,T,R0);
 sigma= (temp/R0)^2*mu/rho;
 La0p25 = (temp/R0)^2*mu/rho/sqrt(omegasq); %sigma hat
 
  mu = sqrt(T*R0*rho/2.5);
 temp = disp_r0hat(rho,2.5,m,T,R0);
  sigma= (temp/R0)^2*mu/rho;

 La2p5 = (temp/R0)^2*mu/rho/sqrt(omegasq);
 
  mu = sqrt(T*R0*rho/25);
 temp = disp_r0hat(rho,25,m,T,R0);
  sigma= (temp/R0)^2*mu/rho;

 La25 = (temp/R0)^2*mu/rho/sqrt(omegasq);
 
  mu = sqrt(T*R0*rho/100);
 temp = disp_r0hat(rho,100,m,T,R0);
  sigma= (temp/R0)^2*mu/rho;

 La100 = (temp/R0)^2*mu/rho/sqrt(omegasq);
 
%  La2p5 =disp_r0hat(rho,2.5,m,T,R0);
%  La25 =disp_r0hat(rho,25,m,T,R0);
%  La100 =disp_r0hat(rho,100,m,T,R0);
 
 figure(1)
 clf
plot(reroot,imroot,'k'); hold on
plot(reroot,-imroot,'k');
% legend('T=50','T=0.5');

plot(real(La0p25),imag(La0p25),'bo','MarkerFaceColor','b')
plot(real(La2p5),imag(La2p5),'rs','MarkerFaceColor','r')
plot(real(La25),imag(La25),'md','MarkerFaceColor','m')
plot(real(La100),imag(La100),'g^','MarkerFaceColor','g')

plot(real(La0p25),-imag(La0p25),'bo','MarkerFaceColor','b')
plot(real(La2p5),-imag(La2p5),'rs','MarkerFaceColor','r')
plot(real(La25),-imag(La25),'md','MarkerFaceColor','m')
plot(real(La100),-imag(La100),'g^','MarkerFaceColor','g')
% 
set(gca,'yaxisloc','right')
set(gca,'YTick',[-1:2:1])

set(gca,'XTick',[-0.5:0.5:0])
set(gca,'FontSize',20);
axis([-0.5 0 -1.5 1.5]);

xL = xlim;
yL = ylim;
line(xL, [0 0],'color','k','linewidth',1) %x-axis
% line([0 0], yL,'color','k','linewidth',1) %y-axis

xlabel('$\Re(\hat{\sigma})$','Interpreter','latex');
ylabel('$\Im(\hat{\sigma})$','Interpreter','latex','Rotation',0);
set(gcf,'units','inch','position',[40,60,6,6]);

% legend('Locus of discrete roots');
set(gcf,'color','w')
% export_fig(gcf,'La2-5m2.eps');

% hold off

%% for m=3 Fig3b

rho=1;
T=0.5;

R0=1;
m=3;
omegasq = (T*m*(m^2-1) )/(rho)/R0^3;

La(1)=0.001;

for jk=1:139
    
  mu = sqrt(T*R0*rho/La(jk));

  temp =disp_r0hat(rho,La(jk),m,T,R0);
  if (real(temp)<0)
      disp('R0hat not accpeted real part negative, change initial guess in fsolve');
      break;
  end
  roots(jk) = (temp/R0)^2*mu/rho/sqrt(omegasq);

  La(jk+1) = exp(0.1*jk)-1;
end

reroot = double(real(roots))';
imroot = double(imag(roots))';

mu = sqrt(T*R0*rho/0.25);
 temp = disp_r0hat(rho,0.25,m,T,R0);
  sigma= (temp/R0)^2*mu/rho;

 La0p25 = (temp/R0)^2*mu/rho/sqrt(omegasq);
 
  mu = sqrt(T*R0*rho/2.5);
 temp = disp_r0hat(rho,2.5,m,T,R0);
  sigma= (temp/R0)^2*mu/rho;

 La2p5 = (temp/R0)^2*mu/rho/sqrt(omegasq);
 
  mu = sqrt(T*R0*rho/25);
 temp = disp_r0hat(rho,25,m,T,R0);
  sigma= (temp/R0)^2*mu/rho;

 La25 = (temp/R0)^2*mu/rho/sqrt(omegasq);
 
  mu = sqrt(T*R0*rho/100);
 temp = disp_r0hat(rho,100,m,T,R0);
  sigma= (temp/R0)^2*mu/rho;

 La100 = (temp/R0)^2*mu/rho/sqrt(omegasq);
 
 figure(2)
 clf
plot(reroot,imroot,'k'); hold on
plot(reroot,-imroot,'k');
% legend('T=50','T=0.5');

plot(real(La0p25),imag(La0p25),'bo','MarkerFaceColor','b')
plot(real(La2p5),imag(La2p5),'rs','MarkerFaceColor','r')
plot(real(La25),imag(La25),'md','MarkerFaceColor','m')
plot(real(La100),imag(La100),'g^','MarkerFaceColor','g')

plot(real(La0p25),-imag(La0p25),'bo','MarkerFaceColor','b')
plot(real(La2p5),-imag(La2p5),'rs','MarkerFaceColor','r')
plot(real(La25),-imag(La25),'md','MarkerFaceColor','m')
plot(real(La100),-imag(La100),'g^','MarkerFaceColor','g')
% 
set(gca,'yaxisloc','right')
set(gca,'YTick',[-1:2:1])

set(gca,'XTick',[-0.5:0.5:0])
set(gca,'FontSize',20);
axis([-0.5 0 -1.5 1.5]);

xL = xlim;
yL = ylim;
line(xL, [0 0],'color','k','linewidth',1) %x-axis
% line([0 0], yL,'color','k','linewidth',1) %y-axis

xlabel('$\Re(\hat{\sigma})$','Interpreter','latex');
ylabel('$\Im(\hat{\sigma})$','Interpreter','latex','Rotation',0);
set(gcf,'units','inch','position',[40,60,6,6]);

% legend('Locus of discrete roots');
set(gcf,'color','w')
% export_fig(gcf,'La2-5m2.eps');

% hold off

%% See Farsoiya et. al.(2019) for details 
% This is included as a function to find the roots of non dimensional
% dispersion relation provided as Eq. 3.22 in the manuscript
function di = disp_r0hat(rho,La,m,T,R0)

omegasq = (T*m*(m^2-1) )/(rho)/R0^3;

% dkmmx = @(x) -0.5*(besselk(m-2,x)+besselk(m,x));
% Gx = @(x) x^2 /2/m *besselk(m+1,x) - (m-1)*besselk(m-1,x);
% 
% fun = @(x) x^4 + 2*m*(m+1)*(1.0-Gx(x)/(x*dkmmx(x)))*x^2 + La*m*(m^2-1)*(1-(m+1)/x * besselk(m-1,x)/dkmmx(x));

dkmm1 = @(R0hat) -0.5*(besselk(m-2,R0hat)+besselk(m,R0hat));

G = @(R0hat) R0hat^2 /2/m *besselk(m+1,R0hat) - (m-1)*besselk(m-1,R0hat);

dispersion = @(R0hat) R0hat^4 + 2*m*(m+1)*(1.0-G(R0hat)/(R0hat*dkmm1(R0hat)))*R0hat^2 + La*m*(m^2-1)*(1-(m+1)/R0hat * besselk(m-1,R0hat)/dkmm1(R0hat));

options = optimset('Display','off'); 

di = fsolve(dispersion,10+10i,options); %search in first quadrant generally give accepted roots.
end
